Skip to content
Docs

Create NKS Node Pool

POST/v1/nks/clusters/{cluster_id}/pools

Create a node pool in an NKS cluster

Path ParametersExpand Collapse
cluster_id: string
Body ParametersJSONExpand Collapse
name: string

Name of the node pool.

node_config: NKSNodePoolNodeConfig { boot_volume, instance_type, labels, taints }

Node configuration.

boot_volume: NKSNodePoolBootVolume { size, type }

Boot volume configuration.

size: number

Size of the boot volume in GB.

maximum512
minimum64

Type of the Volume.

One of the following:
"nvme"
"abs"
instance_type: string

Instance type name used for worker nodes. Immutable after pool creation.

labels: optional array of string

Kubernetes labels to apply to each node in the pool. Each entry is “key=value”. Keys under kubernetes.io, k8s.io, and nirvanalabs.io prefixes are reserved. Immutable after pool creation.

taints: optional array of string

Kubernetes taints to apply to each node in the pool at creation time. Each entry is “key=value:Effect” where Effect is NoSchedule, PreferNoSchedule, or NoExecute. Immutable after pool creation.

node_count: optional number

Number of nodes. Must be between 0 and 100.

maximum100
minimum0
tags: optional array of string

Tags to attach to the node pool.

ReturnsExpand Collapse
Operation object { id, created_at, details, 6 more }

Operation details.

id: string

Unique identifier for the Operation.

created_at: string

When the Operation was created.

formatdate-time
details: OperationDetails { changes }

Structured details about what an operation is changing.

changes: OperationChanges { from, to }

Map of changed field names to their from/to diffs. Keys depend on the parent operation’s kind+type.

from: string or number or boolean or array of string

Previous value.

One of the following:
string
number
boolean
array of string
to: string or number or boolean or array of string

New value.

One of the following:
string
number
boolean
array of string

Kind of Operation.

One of the following:
"vm"
"volume"
"vpc"
"firewall_rule"
"nks_cluster"
"nks_node_pool"
project_id: string

Project ID the Operation belongs to.

resource_id: string

ID of the resource that the Operation is acting on.

Status of the Operation.

One of the following:
"pending"
"running"
"done"
"failed"
"unknown"

Type of Operation.

One of the following:
"create"
"update"
"delete"
"restart"
updated_at: string

When the Operation was updated.

formatdate-time

Create NKS Node Pool

curl https://api.nirvanalabs.io/v1/nks/clusters/$CLUSTER_ID/pools \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $NIRVANA_LABS_API_KEY" \
    -d '{
          "name": "my-node-pool",
          "node_config": {
            "boot_volume": {
              "size": 100,
              "type": "abs"
            },
            "instance_type": "n1-standard-8"
          },
          "node_count": 3,
          "tags": [
            "production",
            "ethereum"
          ]
        }'
{
  "id": "123e4567-e89b-12d3-a456-426614174000",
  "created_at": "2025-01-01T00:00:00Z",
  "details": {
    "changes": {
      "foo": {
        "from": "string",
        "to": "string"
      }
    }
  },
  "kind": "vm",
  "project_id": "123e4567-e89b-12d3-a456-426614174000",
  "resource_id": "123e4567-e89b-12d3-a456-426614174000",
  "status": "pending",
  "type": "create",
  "updated_at": "2025-01-01T00:00:00Z"
}
Returns Examples
{
  "id": "123e4567-e89b-12d3-a456-426614174000",
  "created_at": "2025-01-01T00:00:00Z",
  "details": {
    "changes": {
      "foo": {
        "from": "string",
        "to": "string"
      }
    }
  },
  "kind": "vm",
  "project_id": "123e4567-e89b-12d3-a456-426614174000",
  "resource_id": "123e4567-e89b-12d3-a456-426614174000",
  "status": "pending",
  "type": "create",
  "updated_at": "2025-01-01T00:00:00Z"
}